<?php





/**





 * @author SimonTech


 * @copyright Copyright (C) 2011 Centurion Club. All Rights Reserved.


 * @license - http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL


 * Websites: http://www.simontech.me





*/





defined('_JEXEC') or die;





class Award_managerModelvotes extends JModelLegacy


{





  /**


   * Returns a Table object, always creating it


   *


   * @param   type    $type    The table type to instantiate


   * @param   string  $prefix  A prefix for the table class name. Optional.


   * @param   array   $config  Configuration array for model. Optional.


   *


   * @return  JTable  A database object


   *


   * @since   1.6


   */


  public function getTable($type = 'vote', $prefix = 'Award_managerTable', $config = array())


  {


    // add table path for when model gets used from other component


    $this->addTablePath(JPATH_ADMINISTRATOR . '/components/com_award_manager/tables');


    // get instance of the table


    return JTable::getInstance($type, $prefix, $config);


  }





    public function countForResources($type, array $ids = array())


    {


        $vote = $this->getTable();





        if (!$ids) {


            return array();


        }





        $dbo = $this->getDbo();


        $query = $dbo->getQuery(true)


            ->select($dbo->qn('l.resource_id'))


            ->select('COUNT(1) AS votes')


            ->from($dbo->qn($vote->getTableName(), 'l'))


            ->where($dbo->qn('l.resource_type') . ' = ' . $dbo->q($type))


            ->where($dbo->qn('l.resource_id') . ' IN (' . implode(',', $dbo->q($ids)) . ')')


            ->group($dbo->qn('l.resource_id'));





        $results = $dbo->setQuery($query)


            ->loadAssocList('resource_id');





        return $results;


    }











    public function findByUserForResources($userId, array $types = array(), array $ids = array())


    {


        $vote = $this->getTable();





        if (!$userId || !$ids) {


            return array();


        }





        $dbo = $this->getDbo();


        $query = $dbo->getQuery(true)


            ->select($dbo->qn('v.resource_id'))


            ->from($dbo->qn($vote->getTableName(), 'v'))


            //->where($dbo->qn('v.resource_type') . ' = ' . $dbo->q($type))


            ->where($dbo->qn('v.resource_type') . ' IN (' . implode(',', $dbo->q($types)) . ')')


            ->where($dbo->qn('v.resource_id') . ' IN (' . implode(',', $dbo->q($ids)) . ')')


            ->where($dbo->qn('v.user_id') . ' = ' . $dbo->q($userId));





        $results = $dbo->setQuery($query)


            ->loadAssocList('resource_id');





        return $results;


    }





    public function findvotes($resource, $resourceId)


    {


        $dbo = $this->getDbo();


        $vote = $this->getTable();


        $profile = $this->getTable('member', 'Award_managerTable', array());





        $query = $dbo->getQuery(true)


            ->select('l.*')


            ->from($dbo->qn($vote->getTableName(), 'l'))


            ->order($dbo->qn('l.created') . ' DESC');





        $query->where($dbo->qn('l.resource_type') . ' = ' . $dbo->q($resource))


            ->where($dbo->qn('l.resource_id') . ' = ' . $dbo->q($resourceId));





        $query->select('prf.profile_image, prf.name, prf.id')


            ->leftJoin($dbo->qn($profile->getTableName(), 'prf') . ' ON prf.user = l.user_id');





        $result = $dbo->setQuery($query)


            ->loadObjectList();





        return $result;


    }





    /**


     * @param $resource


     * @param $id


     *


     * @return Award_managerTablevote[]


     */


    public function findByResource($resource, $id)


    {


        $dbo = $this->getDbo();


        $vote = $this->getTable();





        $query = $dbo->getQuery(true)


            ->select('l.*')


            ->from($dbo->qn($vote->getTableName(), 'l'))


            ->where($dbo->qn('l.resource_type') . ' = ' . $dbo->q($resource))


            ->where($dbo->qn('l.resource_id') . ' = ' . $dbo->q($id));





        $results = $dbo->setQuery($query)


            ->loadObjectList('id', get_class($vote));





        return $results;


    }


}


